<?php

/* plugin.quiz_fi.php

Versio 10.0

/kisa auki --> avaa kisan
/kisa kiinni --> sulkee kisan
/nollaa    --> toimii vain admineilla
/kysy      --> esit� kysymys, eroita vastaukset pilkulla
/kysymys   --> kirjoittaa kysymyksen uudelleen
/vastaus   --> esitt�� vastauksen serverill� ja kysy� saa taas

*/


Aseco::registerEvent('onStartup', 'quizbot_startup');
Aseco::registerEvent('onChat', 'quizbot_chat');
# Aseco::registerEvent('onPlayerDisconnect', 'quizbot_disconnect');
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'event_points');

Aseco::addChatCommand('pisteet', 'Shows quiz points');
Aseco::addChatCommand('tilanne', 'Shows quiz points');
Aseco::addChatCommand('nollaa', 'Resets the Quiz');
Aseco::addChatCommand('kisa', 'Control the Quiz on / off');
Aseco::addChatCommand('kysy', 'Ask a question, right answer after questionmark');
Aseco::addChatCommand('kysymys', 'Ask a question, right answer after questionmark');
Aseco::addChatCommand('vastaus', 'Shows right answer and grants right to ask again');
Aseco::addChatCommand('peruuta', 'Cancels the question');
Aseco::addChatCommand('piste', 'Grants a point to player, if admin');
Aseco::addChatCommand('ohje', 'Shows quiz help');


function quiz_sort($a,$b) 
	{
		if($a["Points"]==$b["Points"]) return 0;
		return $a["Points"]<$b["Points"]?1:-1;
	}

class quizbot
	{
		public $Aseco;
		public $points;
		public $rightAnswer;
		public $Question;
		public $asker;
		public $QuestionDB;      // array("question", array("answer"), "login", "nick");
		public $QuestionCounter;
		public $enabled;
		public $addpoint = true;
		public $quiz_admins = array("reaby","samp","hattara");  // ADMINIT

		function checkChatText(&$command)
		{
			// ignore text that comes from the server
			// also ignore anything that looks like its a command
			if ( $command[0] == 0 || substr($command[2], 0, 1) == '/' )      // $command[0] is the player id, 0 = server
			{
			return;
			}

			if ( isset($this->QuestionDB))  
			{

				if ( $command[1] != $this->QuestionDB[0]['login']) // ignore if answer is from asker
				{
					$playeranswer = strtolower($command[2]);
					
					foreach($this->QuestionDB[0]['answer'] as $answer) 
					{
						if ( $playeranswer == trim(strtolower($answer)) )
						{
							$message = "{#server}>> \$0b0 Oikein! \$fff".$answer;
							$this->Aseco->client->query('GetPlayerInfo', $command[1]);
							$info = $this->Aseco->client->getResponse();
							$nick = $info['NickName'];
							$this->points[$command[1]]['NickName'] = $nick;
							$this->points[$command[1]]['Points']++;
							$this->Aseco->client->query("ChatSendServerMessage", $this->Aseco->formatColors($message));
							$this->points();  // show points at successcull answer
							unset($this->QuestionDB[0]);
							$this->checkQueue();
							return;
						}
					
					} // foreach		
				
				} 
			}
		} //  checkChatText

		function ask_question($command,$login) 
		{
			if (isset($this->enabled))
			{
			
					$this->asker = $login;
					$pos = strpos($command,"?");
					
					if ($pos == false) 
					{
						$message = "{#server}> {#error}Kysymys puuttuu";
						$this->Aseco->client->query("ChatSendServerMessageToLogin", $this->Aseco->formatColors($message), $login);
						return;
					}
					
						
					$answer = trim(str_replace("?","",strstr($command,"?"))); 
					
					if ( ($answer = $this->trimString($answer)) === false) {
						$message = "{#server}> {#error}Vastauksessa tukemattomia merkkejä!";
						$this->Aseco->client->query("ChatSendServerMessageToLogin", $this->Aseco->formatColors($message), $login);
						return;
					}
					
					if ($answer == "") {
						$message = "{#server}> {#error}Vastaus puuttuu";
						$this->Aseco->client->query("ChatSendServerMessageToLogin", $this->Aseco->formatColors($message), $login);
						return;
					}
					
					$answer1 = explode(",",$answer);
					//$this->rightAnswer=$answer1;
					
					$question=trim(substr($command,0,$pos));
					
					if ( empty($question)) 
					{
						$message = "{#server}> {#error}Kysymys puuttuu";
						$this->Aseco->client->query("ChatSendServerMessageToLogin", $this->Aseco->formatColors($message), $login);
						return;
					}
					
					//$this->Question=substr($command,0,$pos);
					$this->Aseco->client->query('GetPlayerInfo', $login);
					$info = $this->Aseco->client->getResponse();
					$nick = $info['NickName'];
					$false = 0;
					$this->QuestionDB[]=array("question" => $question, "answer" => $answer1, "login" => $login, "nick" => $nick, "isAsked" => $false);
					$message = "{#server}> {#message}Kysymys lisätty jonoon";
					$this->Aseco->client->query("ChatSendServerMessageToLogin", $this->Aseco->formatColors($message), $login);
					$this->QuestionCounter++;
					$this->checkQueue();
					return;
					
			} else { // enabled 
			
			$this->Aseco->client->query('ChatSendServerMessageToLogin', $this->Aseco->formatColors('{#server}> {#error}Kisa ei ole auki'), $login);
			
			}			
			
			
		 
		} // function


		function trimString($str) {
			$str = utf8_decode($str);
			for ($i=0;$i<strlen($str);$i++) 
			{ 
				$c = ord($str[$i]);
				if ($c == 32 ) { $output .= chr($c); continue; } // space
				if ($c >= 43 && $c <= 59) { $output .= chr($c); continue ; }// 0-9 + - , . / ; :
				if ($c >= 65 && $c <= 90) { $output .= chr($c); continue; }// A-Z
				if ($c >= 97 && $c <= 122) { $output .= chr($c); continue; }// a-z
				if ($c == 129) { $output .= chr($c); continue; } // €
				if ($c == 196 || $c == 214 || $c == 228 || $c == 246) { $output .= chr($c); continue; } // Ä Ö ä ö 
				return false;
			} 
		return utf8_encode($output);
		}
		
		function checkQueue() {
		foreach($this->QuestionDB as $temp) {
		$newQuestionDB[] = $temp;
		}
		$this->QuestionDB = $newQuestionDB;
		
		if (isset($this->enabled) )
			{
				if ( isset($this->QuestionDB[0]['question']) && ($this->QuestionDB[0]['isAsked'] == 0) ) {
				$message = $this->QuestionDB[0]['nick']." \$fffkysyy: \$z\$s\$fa0".$this->QuestionDB[0]['question']."?";  
				$this->Aseco->client->query("ChatSendServerMessage", $this->Aseco->formatColors($message));				
				$this->QuestionDB[0]['isAsked'] = true;
				}
			}
		
		}
		
		function question_again($command,$login) 
		{
			
			if ( isset($this->QuestionDB[0]['question'])) 
			{
				$this->Aseco->client->query('GetPlayerInfo', $this->QuestionDB[0]['login']);
				$info = $this->Aseco->client->getResponse();
				$nick = $info['NickName'];
					
				$message = $this->QuestionDB[0]['nick']." \$fffkysyy: \$z\$s\$fa0".$this->QuestionDB[0]['question']."?";  
			$this->Aseco->client->query("ChatSendServerMessage", $this->Aseco->formatColors($message));
				return;
			}

		}

		function answer($command,$login) 
		{
			if ($login == $this->QuestionDB[0]['login'] || in_array($login,$this->quiz_admins) ) 
			{
				foreach ($this->QuestionDB[0]['answer'] as $info) {
				$answers .=$info.", ";
			}
				$answers = substr($answers,0,-2);
				$message = "{#server}>> {#message}Oikeksi olisi katsottu seuraavat vastaukset: {#highlite}".$answers;
			$this->Aseco->client->query("ChatSendServerMessage", $this->Aseco->formatColors($message));
				unset($this->QuestionDB[0]);
				$this->checkQueue();
			}	

		}
		function cancel($command,$login) 
		{
			if ($login == $this->QuestionDB[0]['login'] || in_array($login,$this->quiz_admins) ) 
			{
				$message = "{#server}>> {#highlite}Kysymys ja vastaus peruutettu!";
				$this->Aseco->client->query("ChatSendServerMessage", $this->Aseco->formatColors($message));
				unset($this->QuestionDB[0]);
				$this->checkQueue();
			}	
		}

		function points() {

			if (count($this->points) >= 1) 
			{
				uasort($this->points,"quiz_sort");
				foreach ($this->points as $info) 
				{
					$message .=$info['NickName'].": \$z\$s\$fff".$info['Points']." ";
				}
			}
			$this->Aseco->client->query("ChatSendServerMessage", $this->Aseco->formatColors($message));
		}

		function player_leave() {
			$message="{#server}>> {#highlite}Kysymys nollattu, pelaaja poistui!";
			$this->Aseco->client->query("ChatSendServerMessage", $this->Aseco->formatColors($message));
		}
		
		function addpoint($player) {
			$this->Aseco->client->query('GetPlayerInfo', $player);
			$info = $this->Aseco->client->getResponse();
			$nick = $info['NickName'];
			$this->points[$player]['NickName'] = $nick;
			$this->points[$player]['Points']++;
			$message="{#server}>> {#highlite}Piste lisätty: ".$nick;
			$this->Aseco->client->query("ChatSendServerMessage", $this->Aseco->formatColors($message));
			$this->points();
		
		}
		function removepoint($player) {
			$this->Aseco->client->query('GetPlayerInfo', $player);
			$info = $this->Aseco->client->getResponse();
			$nick = $info['NickName'];
			$this->points[$player]['NickName'] = $nick;
			$this->points[$player]['Points']--;
			$message="{#server}>> {#highlite}Piste poistettu: ".$nick;
			$this->Aseco->client->query("ChatSendServerMessage", $this->Aseco->formatColors($message));
		
		}

	}

## End of class


	function quizbot_startup()
	{
		global $aseco;
		global $quizbot;
		$quizbot = new quizbot();
		$quizbot->Aseco = $aseco;
	} 

	function quizbot_disconnect($aseco, $player) 
	{
		global $quizbot;
		if ($quizbot->QuestionDB[0]['login'] == $player->login) 
		{
			$quizbot->player_leave();
			return;
		}  
	}

	function quizbot_chat(&$aseco, &$command)
	{
		global $quizbot;
		$quizbot->checkChatText($command);
	} 
   
	function chat_pisteet($aseco, $command) 
	{
		global $quizbot;
		$quizbot->points();
		return;
	}  // chat_quiz_points


	function chat_nollaa($aseco, $command) 
	{
		global $quizbot;
		$player = $command['author'];
		$login = $player->login;
		if ( in_array($login,$quizbot->quiz_admins) ) 
		{
			$message = "{#server}>> {#highlite}Pisteet ja kysymys nollattu!";
			$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
			unset($quizbot->points);
			unset($quizbot->QuestionDB);
			return;
		}
	
	}
	

	function chat_kysy($aseco, $command) 
	{
		global $quizbot;
		$player = $command['author'];
		$login = $player->login;
		if (trim($command['params']) != "") 
		{
			$quizbot->ask_question($command['params'],$login);
			return;
		}
		else {
			$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors('{#server}> {#error}Oikea muoto on: /kysy kysymys? vastaus'), $login);
		return;
		}
		
	}

	function chat_kysymys($aseco, $command) 
	{
		global $quizbot;
		$player = $command['author'];
		$login = $player->login;
		$quizbot->question_again($command['params'],$login);
		return;
	}

	function chat_vastaus($aseco, $command) 
	{
		global $quizbot;
		$player = $command['author'];
		$login = $player->login;
		$quizbot->answer($command['params'],$login);
		return;
	}

	function chat_peruuta($aseco, $command) 
	{
		global $quizbot;
		$player = $command['author'];
		$login = $player->login;
		$quizbot->cancel($command['params'],$login);
		return;
	}

	
	function chat_kisa($aseco, $command) 
	{ 
		global $quizbot;
		$player = $command['author'];
		$login = $player->login;

		if ( in_array($login,$quizbot->quiz_admins)) 
		{ 
			if ($command['params'] == "auki") 
			{
				$quizbot->enabled=true;
				$message = "{#server}>> {#highlite}Kisa avattu!";
				$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
			}
			if ($command['params'] == "kiinni") 
			{ 
				unset($quizbot->enabled);
				unset($quizbot->QuestionDB);
				$message = "{#server}>> {#highlite}Kisa suljettu!";
				$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
			}
		}
	}

	function chat_piste($aseco, $command) {
	global $quizbot;
	// use only first parameter
	if (trim($command['params']) == "") $quizbot->addpoint = true;
	if (trim($command['params']) == "++") $quizbot->addpoint = true;
	if (trim($command['params']) == "--") $quizbot->addpoint = false;
	
	$player = $command['author'];
	$login = $player->login;
	if ( in_array($login,$quizbot->quiz_admins) ) {
		
		$player->playerlist = array();
		if ($quizbot->addpoint == true ) 	$head = 'Anna piste pelaajalle';
		if ($quizbot->addpoint == false )	$head = 'Poista piste pelaajalta';
		
	
			$msg = array();
			$msg[] = array('Id', 'Nick', 'Pisteet');
			$pid = 1;
			$lines = 0;
			$player->msgs = array();
			$player->msgs[0] = array(1, $head, array(1.3, 0.1, 0.9, 0.3), array('Icons128x128_1', 'Buddies'));
			// create list of players, optionally by (sub)string
			foreach ($aseco->server->players->player_list as $pl) {
					$plarr = array();
					$plarr['login'] = $pl->login;
					$player->playerlist[] = $plarr;

					// format nickname & login
					$ply = '{#black}' . $pl->nickname;
					// if points are not set, default to 0
					if (empty($quizbot->points[$pl->login]['Points'])) 
						{
						$pointz = 0; 
						} 
					else 
					{ 
						$pointz = $quizbot->points[$pl->login]['Points']; 
					}
						
					
					// add clickable button
					if ($aseco->settings['clickable_lists'] && $pid <= 200)
						$ply = array($ply, $pid+10000);  // action id

					$msg[] = array(str_pad($pid, 2, '0', STR_PAD_LEFT) . '.', $ply, $pointz);
					$pid++;
					$lines++;
					if ($lines > 14) {
						$player->msgs[] = $msg;
						$lines = 0;
						$msg = array();
						$msg[] = array('Id', 'Nick', 'Pisteet');
					}
				
			}
			// add if last batch exists
			if (count($msg) > 1)
				$player->msgs[] = $msg;

			// display ManiaLink message
			if (count($player->msgs) > 1) {
				display_manialink_multi($player);
			} else {  // == 1
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors('{#server}> {#error}Yhtaan pistetta ei ole annettu'), $player->login);
			}
		}
		
	}
	
function chat_tilanne($aseco, $command) 
	{
	global $quizbot;
	// use only first parameter
	$command['params'] = explode(' ', $command['params'], 2);
	$player = $command['author'];
	$login = $player->login;
	$player->playerlist = array();

		$head = 'Pistetilanne';
			$msg = array();
			$msg[] = array('Nick', 'Pisteet');
			$pid = 1;
			$lines = 0;
			$player->msgs = array();
			$player->msgs[0] = array(1, $head, array(1.2, 0.9, 0.3), array('Icons128x128_1', 'Buddies'));
			// create list of players, optionally by (sub)string
			if (count($quizbot->points) >= 1) {
				uasort($quizbot->points,"quiz_sort");
				foreach ($quizbot->points as $info) 
				{
				print_r($info);
				$plarr = array();
				$plarr['login'] = $pl->login;
				$player->playerlist[] = $plarr;
				$msg[] = array($info['NickName'],$info['Points']);
					$pid++;
					$lines++;
					if ($lines > 14) {
						$player->msgs[] = $msg;
						$lines = 0;
						$msg = array();
						$msg[] = array('Nick', 'Pisteet');
					}
				}
			}
				
			// add if last batch exists
			if (count($msg) > 1)
				$player->msgs[] = $msg;

			// display ManiaLink message
			if (count($player->msgs) > 1) {
				display_manialink_multi($player);
			} else {  // == 1
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors('{#server}> {#error}Ei pisteita'), $player->login);
			}
	}	
	
	
	function chat_ohje($aseco, $command) {
	$player = $command['author'];
	$login = $player->login;
			$header = 'Visailurobootin ohjeet!';
			$help = array();
			$help[] = array('{#server}/kysy kysymys? vastaus, vastaus');
			$help[] = array('{#black}esim /kysy mista paella on? espanjasta, espanja',);
			$help[] = array('{#server}/kysymys');
			$help[] = array('{#black}Julkaise kysymys uudestaan, jos meni ohi');
			$help[] = array('{#server}/peruuta');
			$help[] = array('{#black}Peruuttaa vastauksen ja kysymyksen');
			$help[] = array('{#server}/vastaus');
			$help[] = array('{#black}Julkistaa vastauksen ja nollaa kysymyksen');
			$help[] = array('{#server}/tilanne');
			$help[] = array('{#black}Tulostaulukko');
			$help[] = array('{#black}_____________________________________');
			$help[] = array('{#server}/kisa auki tai /kisa kiinni');
			$help[] = array('{#black}Sulkee ja avaa kisan (admin)');
			$help[] = array('{#server}/piste ++ tai /piste --');
			$help[] = array('{#black}Lisää / poistaa pisteen (admin)');
			$help[] = array('{#server}/nollaa');
			$help[] = array('{#black}Nollaa pisteet (admin)');
	

			// display ManiaLink message
			display_manialink($login, $header, array('Icons64x64_1', 'TrackInfo', -0.01), $help, array(1.0, 1.0), 'OK');
			
	}
	
	function event_points($aseco, $answer) {
	/// $answer[0]=PlayerUid, $answer[1]=Login, $answer[2]=Answer
	global $quizbot;
	// leave actions outside 10001 - 10200 to other handlers
	if ($answer[2] >= 10001 && $answer[2] <= 10200) {
		// get player
		$player = $aseco->server->players->getPlayer($answer[1]);
		$target = $player->playerlist[$answer[2]-10001]['login'];

		// log clicked command
		$aseco->console('player {1} clicked command to add point to {2}"',
		                $player->login, $target);

		// close main window because /stats can take a while
		mainwindow_off($aseco, $player->login);
		// /stats selected player
		$command = array();
		$command['author'] = $player;
		$command['params'] = $target;
		// do counting
		if ($quizbot->addpoint == true ) $quizbot->addpoint($target);
		if ($quizbot->addpoint == false ) $quizbot->removepoint($target);
	}
}  // event_players	
?>